Index: branches/ProblemRefactoring/HeuristicLab.Optimization/3.3/NewInfrastructure/Interfaces.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Optimization/3.3/NewInfrastructure/Interfaces.cs	(revision 14429)
+++ branches/ProblemRefactoring/HeuristicLab.Optimization/3.3/NewInfrastructure/Interfaces.cs	(revision 14429)
@@ -0,0 +1,177 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Threading;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+
+/*************************************************
+ * ********************************************* *
+ *                    DATA                       *
+ * ********************************************* *
+ *************************************************/
+
+
+
+/*************************************************
+   * ********************************************* *
+   *                  OPERATORS                    *
+   * ********************************************* *
+   *************************************************/
+
+
+namespace HeuristicLab.Optimization.LocalSearch {
+  public interface ILocalSearch<TContext> : IItem {
+    void Optimize(TContext context);
+  }
+}
+
+namespace HeuristicLab.Optimization.Crossover {
+  public interface ICrossover<TContext> : IItem {
+
+    void Cross(TContext context);
+  }
+}
+
+namespace HeuristicLab.Optimization.Manipulation {
+  public interface IManipulator<TContext> : IItem {
+    void Manipulate(TContext context);
+  }
+}
+
+namespace HeuristicLab.Optimization.Selection {
+  public interface ISelector<TContext> : IItem {
+
+    void Select(TContext context, int n, bool withRepetition);
+  }
+}
+
+/*************************************************
+   * ********************************************* *
+   *                  CONTEXTS                     *
+   * ********************************************* *
+   *************************************************/
+
+namespace HeuristicLab.Optimization {
+
+  public interface ILongRunningOperationContext : IExecutionContext {
+    CancellationToken CancellationToken { get; set; }
+  }
+
+  public interface IStochasticContext : IExecutionContext {
+    IRandom Random { get; }
+  }
+
+  public interface IEvaluatedSolutionsContext : IExecutionContext {
+    int EvaluatedSolutions { get; }
+    void IncEvaluatedSolutions(int inc);
+  }
+
+  public interface IBestQualityContext : IExecutionContext {
+    double BestQuality { get; set; }
+  }
+
+  public interface IBestSolutionContext<TSolution> : IExecutionContext {
+    TSolution BestSolution { get; set; }
+  }
+
+  public interface IIterationsContext : IExecutionContext {
+    int Iterations { get; }
+  }
+
+  public interface IImprovementStepsContext : IExecutionContext {
+    int ImprovementSteps { get; set; }
+  }
+
+  public interface IProblemContext<TProblem, TEncoding, TSolution> : IExecutionContext
+      where TProblem : class, ISingleObjectiveProblem<TEncoding, TSolution>
+      where TEncoding : class, IEncoding<TSolution>
+      where TSolution : class, ISolution {
+    TProblem Problem { get; }
+  }
+
+  public interface IPopulationContext : IExecutionContext {
+    IEnumerable<IScope> Population { get; }
+  }
+
+  public interface IPopulationContext<TSolution> : IPopulationContext {
+    new IEnumerable<ISolutionScope<TSolution>> Population { get; }
+  }
+
+  public interface ISingleObjectivePopulationContext<TSolution> : IPopulationContext<TSolution> {
+    new IEnumerable<ISingleObjectiveSolutionScope<TSolution>> Population { get; }
+  }
+
+  public interface ISolutionContext : IExecutionContext {
+    IScope Solution { get; }
+  }
+
+  public interface ISolutionContext<TSolution> : ISolutionContext {
+    new ISolutionScope<TSolution> Solution { get; }
+  }
+
+  public interface ISingleObjectiveSolutionContext<TSolution> : ISolutionContext<TSolution> {
+    new ISingleObjectiveSolutionScope<TSolution> Solution { get; }
+  }
+
+  public interface IMatingContext<TSolution> : IExecutionContext {
+    Tuple<ISolutionScope<TSolution>, ISolutionScope<TSolution>>  Parents { get; }
+    ISolutionScope<TSolution> Child { get; }
+  }
+
+  public interface ISingleObjectiveMatingContext<TSolution> : IMatingContext<TSolution> {
+    new Tuple<ISingleObjectiveSolutionScope<TSolution>, ISingleObjectiveSolutionScope<TSolution>> Parents { get; }
+    new ISingleObjectiveSolutionScope<TSolution> Child { get; }
+  }
+
+  public interface IMatingpoolContext<TSolution> : IExecutionContext
+      where TSolution : class, ISolution {
+    IEnumerable<ISolutionScope<TSolution>> MatingPool { get; set; }
+  }
+
+  public interface ISingleObjectiveMatingpoolContext<TSolution> : IMatingpoolContext<TSolution>
+      where TSolution : class, ISolution {
+    new IEnumerable<ISingleObjectiveSolutionScope<TSolution>> MatingPool { get; set; }
+  }
+}
+
+
+/*************************************************
+   * ********************************************* *
+   *                   SCOPES                      *
+   * ********************************************* *
+   *************************************************/
+
+namespace HeuristicLab.Core {
+  public interface ISolutionScope<TSolution> : IScope {
+    TSolution Solution { get; set; }
+
+    void Adopt(ISolutionScope<TSolution> orphan);
+  }
+
+  public interface ISingleObjectiveSolutionScope<TSolution> : ISolutionScope<TSolution> {
+    double Fitness { get; set; }
+
+    void Adopt(ISingleObjectiveSolutionScope<TSolution> orphan);
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Problems.Knapsack/3.3/Analyzers/BestKnapsackSolutionAnalyzer.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.Knapsack/3.3/Analyzers/BestKnapsackSolutionAnalyzer.cs	(revision 13469)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.Knapsack/3.3/Analyzers/BestKnapsackSolutionAnalyzer.cs	(revision 14429)
@@ -60,5 +60,5 @@
     }
     public ILookupParameter<KnapsackSolution> BestSolutionParameter {
-      get { return (ILookupParameter<KnapsackSolution>)Parameters["BestSolution"]; }
+      get { return (ILookupParameter<KnapsackSolution>)Parameters["BestKnapsackSolution"]; }
     }
     public IValueLookupParameter<ResultCollection> ResultsParameter {
@@ -84,5 +84,5 @@
 
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the Knapsack solutions which should be visualized."));
-      Parameters.Add(new LookupParameter<KnapsackSolution>("BestSolution", "The best Knapsack solution."));
+      Parameters.Add(new LookupParameter<KnapsackSolution>("BestKnapsackSolution", "The best Knapsack solution."));
       Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The result collection where the knapsack solution should be stored."));
       Parameters.Add(new LookupParameter<DoubleValue>("BestKnownQuality", "The quality of the best known solution."));
Index: branches/ProblemRefactoring/HeuristicLab.Problems.Knapsack/3.3/KnapsackProblem.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.Knapsack/3.3/KnapsackProblem.cs	(revision 13469)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.Knapsack/3.3/KnapsackProblem.cs	(revision 14429)
@@ -91,4 +91,5 @@
 
       InitializeRandomKnapsackInstance();
+      Encoding.Length = Weights.Length;
 
       InitializeOperators();
@@ -97,10 +98,12 @@
 
     public override double Evaluate(BinaryVector solution, IRandom random) {
+      var weights = Weights;
+      var values = Values;
       var totalWeight = 0.0;
       var totalValue = 0.0;
       for (var i = 0; i < solution.Length; i++) {
         if (!solution[i]) continue;
-        totalWeight += Weights[i];
-        totalValue += Values[i];
+        totalWeight += weights[i];
+        totalValue += values[i];
       }
       return totalWeight > KnapsackCapacity ? KnapsackCapacity - totalWeight : totalValue;
@@ -253,5 +256,6 @@
       var sysrand = new System.Random();
 
-      var itemCount = sysrand.Next(10, 100);
+      var power = sysrand.Next(5, 11);
+      var itemCount = (int)Math.Pow(2, power);
       Weights = new IntArray(itemCount);
       Values = new IntArray(itemCount);
@@ -260,6 +264,6 @@
 
       for (int i = 0; i < itemCount; i++) {
-        var value = sysrand.Next(1, 10);
-        var weight = sysrand.Next(1, 10);
+        var value = sysrand.Next(1, 30);
+        var weight = sysrand.Next(1, 30);
 
         Values[i] = value;
@@ -268,5 +272,5 @@
       }
 
-      KnapsackCapacity = (int)Math.Round(0.7 * totalWeight);
+      KnapsackCapacity = (int)Math.Round(0.5 * totalWeight);
     }
   }
Index: branches/ProblemRefactoring/HeuristicLab.Selection/3.3/TournamentSelector.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Selection/3.3/TournamentSelector.cs	(revision 13469)
+++ branches/ProblemRefactoring/HeuristicLab.Selection/3.3/TournamentSelector.cs	(revision 14429)
@@ -27,4 +27,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Selection;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -90,3 +91,62 @@
     }
   }
+
+  [Item("Tournament Selector", "", ExcludeGenericTypeInfo = true)]
+  [StorableClass]
+  public sealed class TournamentSelector<TContext, TProblem, TEncoding, TSolution> : ParameterizedNamedItem, ISelector<TContext>
+      where TContext : ISingleObjectivePopulationContext<TSolution>, IMatingpoolContext<TSolution>, IStochasticContext,
+                       IProblemContext<TProblem, TEncoding, TSolution>
+      where TProblem : class, ISingleObjectiveProblem<TEncoding, TSolution>, ISingleObjectiveProblemDefinition<TEncoding, TSolution>
+      where TEncoding : class, IEncoding<TSolution>
+      where TSolution : class, ISolution {
+
+    [Storable]
+    private IValueParameter<IntValue> groupSizeParameter;
+    public int GroupSize {
+      get { return groupSizeParameter.Value.Value; }
+      set {
+        if (value < 1) throw new ArgumentException("Cannot use a group size less than 1 in tournament selection.");
+        groupSizeParameter.Value.Value = value;
+      }
+    }
+    
+    [StorableConstructor]
+    private TournamentSelector(bool deserializing) : base(deserializing) { }
+    private TournamentSelector(TournamentSelector<TContext, TProblem, TEncoding, TSolution> original, Cloner cloner)
+      : base(original, cloner) {
+      groupSizeParameter = cloner.Clone(groupSizeParameter);
+    }
+    public TournamentSelector() {
+      Parameters.Add(groupSizeParameter = new ValueParameter<IntValue>("GroupSize", "The group size that competes in the tournament.", new IntValue(2)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TournamentSelector<TContext, TProblem, TEncoding, TSolution>(this, cloner);
+    }
+
+    public void Select(TContext context, int n, bool withRepetition) {
+      context.MatingPool = Select(context.Random, context.Problem.IsBetter, context.Population, GroupSize, n, withRepetition);
+    }
+
+    public static IEnumerable<ISingleObjectiveSolutionScope<TSolution>> Select(IRandom random, Func<double, double, bool> isBetterFunc, IEnumerable<ISingleObjectiveSolutionScope<TSolution>> population, int groupSize, int n, bool withRepetition) {
+      var pop = population.Where(x => !double.IsNaN(x.Fitness)).ToList();
+
+      var i = n;
+      while (i > 0 && pop.Count > 0) {
+        var best = random.Next(pop.Count);
+        for (var j = 1; j < groupSize; j++) {
+          var index = random.Next(pop.Count);
+          if (isBetterFunc(pop[index].Fitness, pop[best].Fitness)) {
+            best = index;
+          }
+        }
+
+        yield return pop[best];
+        i--;
+        if (!withRepetition) {
+          pop.RemoveAt(i);
+        }
+      }
+    }
+  }
 }
